<template>
    <div class="parallax-wrapper">
      <div class="parallax-container" ref="containerRef">
        <div class="message">
          <h1>404</h1>
          <p>It looks like the page you're looking for is missing.</p>
          <p @click="()=> $router.push('/')">Home page</p>
        </div>
        <div class="parallax-layer layer1"></div>
        <div class="parallax-layer layer2"></div>
      </div>
    </div>
    <el-button
      @click="toggleDark()"
      style="z-index: 2; width: 5%; height: 5%; padding: 1.5rem; position: absolute; right: 0; margin-right: 0.5rem;"
    >
      <img :src="isDark ? `/svg/moon.svg` : `/svg/sun.svg`" alt="SVG" />
    </el-button>
  </template>
  
  <style lang="scss" scoped>
  @import '../../sass/app.scss';
  @import url("https://fonts.googleapis.com/css2?family=Poppins:wght@700&display=swap");

  .message {
    color: var(--el-color-black);
    z-index: 999;
    font-family: "Poppins", sans-serif;
    text-align: center;
  }
  
  .message h1 {
    font-size: 8vw; /* Use viewport units for font size */
    margin:0;
  }
  
  .message p {
    font-size: 1vw;
  }
  
  .message p:hover {
    cursor: pointer;
  }
  
  .parallax-wrapper {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
  }
  
  .parallax-container {
    display: flex;
    justify-content: center;
    align-items: center;
  }
  
  .parallax-layer {
    position: absolute;
    opacity: 0;
  }
  
  .layer1 {
    width: 45vw; /* Use viewport units for width */
    height: 45vw; /* Use viewport units for height */
    border-radius: 100%;
    animation: pop-up 1s 0.8s forwards;
  }
  
  .layer2 {
    border-radius: 100%;
    width: 50vw; /* Use viewport units for width */
    height: 50vw; /* Use viewport units for height */
    z-index: -1;
    animation: pop-up 1s 0.5s forwards;
  }
  
  .pop-up-text {
    opacity: 0;
    animation: pop-up-text 1s forwards;
  }
  
  @keyframes pop-up {
    0% {
      opacity: 0;
    }
    20% {
      opacity: 0.2;
    }
    40% {
      opacity: 0.4;
    }
    60% {
      opacity: 0.6;
    }
    80% {
      opacity: 0.8;
    }
    100% {
      opacity: 1;
    }
  }
  
  @keyframes pop-up-text {
    0% {
      opacity: 0;
      transform: scale(0);
    }
    100% {
      opacity: 1;
      transform: scale(1);
    }
  }
  </style>
  
  <script setup>
  import { onMounted, ref } from 'vue';
  import { useDark, useToggle } from '@vueuse/core';
  
  const containerRef = ref(null);
  
  onMounted(() => {
    const container = containerRef.value;
    const layer1 = container.querySelector('.layer1');
    const layer2 = container.querySelector('.layer2');
  
    container.addEventListener('mousemove', (e) => {
      const containerRect = container.getBoundingClientRect();
      const containerCenterX = containerRect.left + containerRect.width / 2;
      const containerCenterY = containerRect.top + containerRect.height / 2;
  
      const x = (e.clientX - containerCenterX) / containerRect.width;
      const y = (e.clientY - containerCenterY) / containerRect.height;
  
      layer1.style.transform = `translate(${-x * 40}px, ${-y * 40}px)`;
      layer2.style.transform = `translate(${-x * 30}px, ${-y * 30}px)`;
    });
  });
  
  const isDark = useDark();
  const toggleDark = useToggle(isDark);
  </script>
  